package com.example.ellegadodepintia

import android.content.Intent
import android.os.Bundle
import android.widget.Button
import android.widget.ImageView
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.Jugador

class MainActivity : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        GameState.jugador = Jugador()

        val signInButton = findViewById<Button>(R.id.signInButton)
        signInButton.setOnClickListener {
            val intent = Intent(this, AuthActivity::class.java)
            startActivity(intent)
        }

        val logInButton = findViewById<Button>(R.id.loginButton)
        logInButton.setOnClickListener {
            val intent = Intent(this, MapActivity::class.java)
            startActivity(intent)
        }

        val botonSecreto = findViewById<ImageView>(R.id.logoImageView)
        var clickCount = 0
        val clickThreshold = 3
        val clickTimeout = 2000L
        val resetClickCountRunnable = Runnable {
            clickCount = 0
        }
        botonSecreto.setOnClickListener {
            clickCount++
            botonSecreto.removeCallbacks(resetClickCountRunnable)
            botonSecreto.postDelayed(resetClickCountRunnable, clickTimeout)
            if (clickCount == clickThreshold) {
                clickCount = 0
                Toast.makeText(this, "Modo developer", Toast.LENGTH_SHORT).show()
                val intent = Intent(this, ListaMinijuegos::class.java)
                startActivity(intent)
            }
        }
    }
}